<?php
//
//   CF Image Hosting Script 
//   --------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.4.1
//   Date:      03 April 2011
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost/
//
//   Copyright (c) 2011 codefuture.co.uk
//   This file is part of the CF Image Hosting Script.
//
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
//   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
//   OR  IN  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//
//  You may not modify and/or remove any copyright notices or labels on the software on each
//  page (unless full license is purchase) and in the header of each script source file.
//
//  You should have received a full copy of the LICENSE AGREEMENT along with
//  CF Image Hosting Script.  If not, see http://codefuture.co.uk/projects/imagehost/license/
//   
////////////////////////////////////////////////////////////////////////////////////

	require_once('inc/config.php');

	if(!$settings['SET_HIDE_SEARCH']){
		header('Location: index.php');
		exit();
	}

	$string = '';

	if( !empty ( $_GET['search'] ) ){
		$string = input($_GET['search']);
		$clean_string = new cleaner();
		$stemmed_string = $clean_string->parseString($string);

		if(!empty($stemmed_string)){

			$new_string = '';
			foreach ( array_unique ( split ( " ",$stemmed_string ) ) as $array => $value ){
				if(strlen($value) > 2)
					$new_string .= ''.$value.' ';
			}
			$new_string = substr ( $new_string,0, ( strLen ( $new_string ) -1 ) );
			if ( strlen ( $new_string ) <= 2 ){
				$Err['site_search'] = $LANGUAGE_PACK["site_search_err_short"];
			}
		}else{
			$Err['site_search'] = $LANGUAGE_PACK["site_search_err_blank"];
		}
	}else{
		$Err['site_search'] = $LANGUAGE_PACK["site_search_err_blank"];
	}

///////////////////////////////////////////////////

// see what page we are on
	$page_number = (isset($_GET['p']) ? input($_GET['p'])-1:0);// 0=1st

// count images in db to see if we need to make a page
	if(empty($Err) && $imageList = imageList(($page_number*$settings['SET_IMG_ON_PAGE']),null,'added','ASC',$new_string)){

	// page pagination
		$pagination = pagination($page_number, $settings['SET_IMG_ON_PAGE'], $DBCOUNT,'search.php','&search='.$string);

	//inline ad
		$inline_ad = ($settings['SET_GOOGLE_ADS']?'<div class="gallery_ad">'.$gallery_AdSense.'</div>':'');

		$new_row = 1;
		$ad_row = 0;
		$i = 0;

	// make gallery
		$img_gallery ='<ul class="gallery">';
		foreach($imageList as $k=>$item){

		// get image address
			$thumb_url = imageAddress(3,$item['id'],"dt");
		// get thumb page address
			$thumb_mid_link	= imageAddress(2,$item['id'],"pm");
		//see if there is a alt(title) if not use the image name
			$alt_text = ($item['alt'] !="" ? $item['alt']:$item['name']);
		//image list for page
			$img_gallery .= '
						<li><a href="'.$thumb_mid_link.'" title="'.$alt_text.'" class="thumb" >
							<img src="'.$thumb_url.'" alt="'.$alt_text.'" />
							</a><h2><a href="'.$thumb_mid_link.'" title="'.$alt_text.'">'.$alt_text.'</a></h2>
							'.($settings['SET_ALLOW_REPORT']?'<div class="img_report"><a rel="nofollow" href="#" title="'.$LANGUAGE_PACK["site_gallery_report_title"].'" onclick="return doconfirm(\''.$LANGUAGE_PACK["site_gallery_report_this"].'\',\''.$item['id'].'\','.($page_number+1).');">'.$LANGUAGE_PACK["site_gallery_report"].'</a></div>':'').'
							<div class="info">'.$item['dimensions_x'].'x'.$item['dimensions_y'].' '.format_size($item['size']).'</div>
						</li>';
			if($new_row == 4 && $i != ($settings['SET_IMG_ON_PAGE']-1)){
				$img_gallery .= '</ul>'.($ad_row ==0?$inline_ad:'').'<ul class="gallery">';
				$new_row = 1;
				$ad_row++;
			}else
				$new_row++;
			 $i++;

		}//	endfor
		$img_gallery .= '</ul>'.$pagination;
	}

// gallerie end
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
// MAKE PAGE END

	$menu = 'gallery';
	$page_title = $page_number == 0 ? ' - '.$LANGUAGE_PACK["site_search_page_title"].' '.$string.' Page 1':' - '.$LANGUAGE_PACK["site_search_page_title"].' '.$string.' Page '.($page_number+1);
	include_once('header.php');
		echo error_note($Err);
		
		if (isset($img_gallery)){
			echo '<h4 class="search">'.sprintf($LANGUAGE_PACK["site_search_results"],'<span class="search_for">'.$DBCOUNT.'</span>').' <span class="search_for">'.$string.'</span></h4>';
			echo $img_gallery;
		}else{
			echo '<h4 class="search">'.$LANGUAGE_PACK["site_search_no_results"].' <span class="search_for">'.$string.'</span></h4>';
			echo '<p class="search_sug">'.$LANGUAGE_PACK["site_search_suggestions"].'</p>';
		}

	include_once('footer.php');

// MAKE PAGE END
////////////////////////////////////////////////////////////////////////////////////

class Cleaner {

	var $stopwords = array(" find ", " about ", " me ", " ever ", " each ", " the ", " jpg ", " gif ", " png ", " bmp ");//you need to extend this big time.
	var $symbols = array('/','\\','\'','"',',','.','<','>','?',';',':','[',']','{','}','|','=','+','-','_',')','(','*','&','^','%','$','#','@','!','~','`'	);//this will remove punctuation

	function parseString($string) {
		$string = ' '.$string.' ';
		$string = $this->removeStopwords($string);
		$string = $this->removeSymbols($string);
		return $string;
	}
	
	function removeStopwords($string) {
		for ($i = 0; $i < sizeof($this->stopwords); $i++) {
			$string = str_replace($this->stopwords[$i],' ',$string);
		}

		return trim($string);
	}

	function removeSymbols($string) {
		for ($i = 0; $i < sizeof($this->symbols); $i++) {
			$string = str_replace($this->symbols[$i],' ',$string);
		}

		return trim($string);
	}
}

