<?php
//
//   CF Image Hosting Script 
//   --------------------------
//
//   Author:    codefuture.co.uk
//   Version:   1.4.1
//   Date:      03 April 2011
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost/
//
//   Copyright (c) 2011 codefuture.co.uk
//   This file is part of the CF Image Hosting Script.
//
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
//   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
//   OR  IN  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//
//  You may not modify and/or remove any copyright notices or labels on the software on each
//  page (unless full license is purchase) and in the header of each script source file.
//
//  You should have received a full copy of the LICENSE AGREEMENT along with
//  CF Image Hosting Script.  If not, see http://codefuture.co.uk/projects/imagehost/license/
//   
////////////////////////////////////////////////////////////////////////////////////

	require_once('inc/config.php');

	if($settings['SET_DIS_UPLOAD'] && !checklogin()){
		header('Location: index.php');
		exit();
	}

////////////////////////////////////////////////////////////////////////////////////
// UPLOAD CODE START

// see if user is banned
	if (db_isBanned()){
		$Err['upload_ban'] = $LANGUAGE_PACK["site_upload_banned"];
	}

// see if a image url has been posted
	if((isset($_POST['imgUrl']) && !empty($_POST['imgUrl'])) || isset($imgApiUrl)){
		$imageURL = input(isset($_POST['imgUrl'])?$_POST['imgUrl']:$imgApiUrl);
		require_once("lib/remoteImage.class.php");
		$remoteImage = new remoteImages($DIR_TEMP,$settings,$LANGUAGE_PACK);
		$remoteImage->validExtensions	= $accepted;
		$remoteImage->validType			= $acceptedtyp;
		$remoteImage->minDimensions		= $IMG_MIN_SIZE;
		$remoteImage->maxDimensions		= $IMG_MAX_SIZE;

		if($remoteImage->getImage($imageURL)){
		//check that a file has been found and copyed to the temp dir
			if(!is_null($remoteImage->file)){
				$_FILES = $remoteImage->file;
			}
		}else{
			$Err['remoteImages'] = $remoteImage->error;
		}
	}

	if(	($_SERVER['REQUEST_METHOD'] == 'POST' || isset($api)) &&
		@$_FILES['file']['name'][0] !='' && 
		empty($Err)){

		require_once("lib/resize.class.php");
		require_once("lib/phpDupeImage.php");

		$imgCount = 0;
		unset($_SESSION['upload']);

		for($i=0; $i < count($_FILES['file']['name']);$i++){
			$pieces = explode("?", $_FILES['file']['name'][$i]);
			$file_name		= $pieces[0];
			$file_tmp_name	= $_FILES['file']['tmp_name'][$i];
			$file_size		= $_FILES['file']['size'][$i];
			$file_type		= strtolower($_FILES['file']['type'][$i]);

			$get_img 		= @getimagesize($file_tmp_name);
			$path_info		= pathinfo($file_name);
			$imgAlt			= removeSymbols(input(!empty($_POST["alt"][$i])?$_POST["alt"][$i]:(isset($imgApiAlt) && !empty($imgApiAlt)?$imgApiAlt:$path_info['filename'])));
			$err_get_img	= false;

		//min size(pixels)
			if ($get_img[0] < $IMG_MIN_SIZE ||
				$get_img[1] < $IMG_MIN_SIZE ){
				$err_get_img = true;
				$Err['image_size'] = sprintf($LANGUAGE_PACK["site_upload_to_small"],$IMG_MIN_SIZE.'x'.$IMG_MIN_SIZE).'<br/>';
			}

		// max size(pixels)
			if ($get_img[0] > $IMG_MAX_SIZE ||
				$get_img[1] > $IMG_MAX_SIZE ){
				$err_get_img = true;
				$Err['image_size'] = sprintf($LANGUAGE_PACK["site_upload_to_big"],$IMG_MAX_SIZE.'x'.$IMG_MAX_SIZE).'<br/>';
			}

		//Check file size (kb)
			if($file_size >= $settings['SET_MAXSIZE']){
				$err_get_img = true;
				$Err['image_size_kb'] = sprintf($LANGUAGE_PACK["site_upload_size_accepted"],format_size($settings['SET_MAXSIZE'])).'<br/>';
			}

		//check file type
			if (!isset($path_info['extension']) ||
				!(in_array(strtolower($path_info['extension']), $accepted)) ||
				!(in_array($file_type, $acceptedtyp))){
				$err_get_img = true;
				$Err['image_type'] = sprintf($LANGUAGE_PACK["site_upload_types_accepted"],$types).'<br/>'.'file_type = '.$file_type.' / extension = '.@strtolower($path_info['extension']).'<br/>'; // bebug file type strtolower($_FILES["file"]["type"])
			}

		//Make Image fingerprint
			if(!$err_get_img) {
				$finger = new phpDupeImage();
				$fingerprint = $finger->fingerprint($file_tmp_name);
			}
		//check for Duplicate Images
			if(!$err_get_img && $settings['SET_NODUPLICATE']){
			// If similar files exist, check them
				if($fp=findImage('fingerprint',$fingerprint)){
					for($ad=0; $ad < count($fp);$ad++){
						if ($finger->are_duplicates($file_tmp_name,imageAddress(1,$fp[$ad]['id'],null,$fp[$ad]))){
							$err_get_img = true;
							$ad =  count($fp);
							$Err['image_Dupe'] = $LANGUAGE_PACK["upload_duplicate_found"];
						}
					}
				}
			}

			if(!$err_get_img) {

			//New random name
			//Number of Possible Combinations
			//  3 digit code 46656
			//  4 digit code 1679616
			//  5 digit code 60466176
				$newname = createHash(4,true);

			//random delete ID
				$delete_id = $newname.createHash(6);
			
			// extension
				$IMG_EXT = strtolower($path_info['extension']);

			//Image address
				$IMG_NAME = $newname.'.'.$IMG_EXT;
				$IMG_ADDRESS = $DIR_IMAGE.$IMG_NAME;

			//Move image
				$IMG_MOVED = false;


			// psd -> png -> move
				if($IMG_EXT == 'psd' || $IMG_EXT == 'bmp'){
				//Reset Image address
					$IMG_EXT = ($IMG_EXT == 'psd'?$PNG_SAVE_EXT:$JPG_SAVE_EXT);
					$IMG_NAME = $newname.'.'.$IMG_EXT;
					$IMG_ADDRESS = $DIR_IMAGE.$IMG_NAME;
				// convert psd/bmp to png
					$convert = new resize($file_tmp_name);
					$convert->imageConvert($IMG_ADDRESS,($IMG_EXT == 'psd'?$PNG_QUALITY:$JPG_QUALITY));
					$convert->destroyImage();
				// remove old file
					if(file_exists($file_tmp_name))unlink($file_tmp_name);
				// move file
					if(file_exists($IMG_ADDRESS))$IMG_MOVED = true;
				}
		
			//move image from remote server
				elseif(isset($imageURL) && input($imageURL) != ''){
					@copy($file_tmp_name,$IMG_ADDRESS);
					@unlink($file_tmp_name);
					$IMG_MOVED = true;
				}
			
			//move uploaded image
				elseif (move_uploaded_file($file_tmp_name,$IMG_ADDRESS)){
					if(@file_exists($file_tmp_name))@unlink($file_tmp_name);
					$IMG_MOVED = true;
				}

			//Resize image if needed
				if ($IMG_MOVED && $settings['SET_RESIZE_IMG_ON']) {

					if((isset($_POST['new_width'][$i]) && !empty($_POST['new_width'][$i])) ||
						(isset($_POST['new_height'][$i]) && !empty($_POST['new_height'][$i]))){

						$new_dim = new resize($IMG_ADDRESS);
						$new_dim -> stretchSmallImages(TRUE);

						if(!empty($_POST['new_width'][$i]) && !empty($_POST['new_height'][$i])){
							$new_dim -> resizeImage($_POST['new_width'][$i], $_POST['new_height'][$i], 'exact');
						}
						elseif(!empty($_POST['new_width'][$i]) && empty($_POST['new_height'][$i])){
							$new_dim -> resizeImage($_POST['new_width'][$i], $get_img[0], 'landscape');
						}
						elseif(empty($_POST['new_width'][$i]) && !empty($_POST['new_height'][$i])){
							$new_dim -> resizeImage($get_img[1], $_POST['new_height'][$i], 'portrait');
						}

						$new_dim -> saveImage($IMG_ADDRESS,100);
						$new_dim -> destroyImage();
						$get_img = @getimagesize($IMG_ADDRESS);// update image size for db
					}
				}

			//Attempt to move the uploaded file to the upload folder
				if ($IMG_MOVED) {

				//Thumb address
					$THUMB_NAME = $newname.'.'.$IMG_EXT;
					$THUMB_ADDRESS = $DIR_THUMB.$THUMB_NAME;
					$THUMB_MID_ADDRESS = $DIR_THUMB_MID.$THUMB_NAME;

				// thumb
					$resize = new resize($IMG_ADDRESS);
					$resize ->setMemoryLimit ($IMG_MEMORY_LIMIT);
					$resize ->setTweakFactor ($IMG_TWEAK_FACTOR);
				// make thumb
					$resize -> resizeImage($THUMB_MID_MAX_WIDTH, $THUMB_MID_MAX_HEIGHT, $THUMB_MID_OPTION);
					$resize -> saveImage($THUMB_MID_ADDRESS, ($IMG_EXT == 'psd'?$PNG_QUALITY:$JPG_QUALITY));
				// make small thumb
					$resize -> resizeImage($THUMB_MAX_WIDTH, $THUMB_MAX_HEIGHT, $THUMB_OPTION);
					$resize -> saveImage($THUMB_ADDRESS, ($IMG_EXT == 'psd'?$PNG_QUALITY:$JPG_QUALITY));
					$resize -> destroyImage();

				//see if thumb's got made
					if(file_exists($THUMB_ADDRESS) && file_exists($THUMB_MID_ADDRESS)){

						if (isset($_POST['shorturl'][$i]) && $_POST['shorturl'][$i] == 1 && $settings['SET_SHORT_URL_ON']){
							$shorturl = shorturl_url('http://'.$_SERVER['HTTP_HOST'].preg_replace('/\/([^\/]+?)$/', '/', $_SERVER['PHP_SELF']).'?di='.$newname);
						}else{
							$shorturl = null;
						}

					// get thumb's file size
						$file_size = @filesize($IMG_ADDRESS);
						$thumbsize = @filesize($THUMB_MID_ADDRESS);
						$sthumbsize = @filesize($THUMB_ADDRESS);

					// move images to the right server
					//	$server_id = sendByFTP($newname,$IMG_EXT);

					// Make image info array to save to db
						$newImageArray = array(	'id'		=> $newname,
												'name'		=> $file_name,
												'alt'		=> $imgAlt,
												'added'		=> time(),
												'ext'		=> $IMG_EXT,
												'ip'		=> $_SERVER['REMOTE_ADDR'],
												'size'		=> $file_size,
												'deleteid'	=> $delete_id,
												'thumbsize' => $thumbsize,
												'sthumbsize'=> $sthumbsize,
												'private'	=> (isset($_POST['private'][$i])?1:0),
												'report'	=> 0,
												'shorturl'	=> $shorturl,
												'dimensions_x' =>$get_img[0],
												'dimensions_y' =>$get_img[1],
												'fingerprint'  =>$fingerprint,
												);

					//save new image to database
						if(addNewImage($newImageArray)){
						// save image to upload array to be sent to thumb page
							$_SESSION['upload'][]= array('id'=>$newname,'did'=> $delete_id);

						// count images uploaded
							$imgCount++;
							if($imgCount >= $settings['SET_MAX_UPLOAD']){
								break;
							}

						}else
							$Err['imagedb'] = $LANGUAGE_PACK["site_index_delete_image_err_db"];
					}else{
						@unlink($IMG_ADDRESS);
						@unlink($THUMB_ADDRESS);
						@unlink($THUMB_MID_ADDRESS);
						$Err['upload_error'] = $LANGUAGE_PACK["site_upload_err"].' -1';
					}
				}else // move the uploaded file
					$Err['upload_error'] = $LANGUAGE_PACK["site_upload_err"].' -2';
			}//name
		}//for
	}

// UPLOAD CODE END
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
// MAKE PAGE

// error send back to home page and show the error
	if(!isset($_SESSION['upload'])){
		$_SESSION['err'] = $Err;
		header('Location: index.php');
		exit();
	}

// open thumb page and show upload images
	header('Location: thumbnail.php');
	exit();

// MAKE PAGE END
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
// functions

// very simple hash function to generate a random string
	function createHash($length=5,$check=null){
		$valid = 0;
		$hash = '';
		while(!$valid){
			for($i=0;$i<$length;$i++){
			// if you want to add letters you will have to change the id to varchar instead of int
				$possibleValues = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
			// pick a random character from the possible ones
	    		$hash .= substr($possibleValues, mt_rand(0, strlen($possibleValues)-1), 1);
			}
		// checks if the hash allready exists in the db
			if(is_null($check) || !getImage($hash)){
				$valid = 1;
			}
		}
		return $hash;
	}